﻿using System;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.JavaScript;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using System.ComponentModel.DataAnnotations;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using Newtonsoft.Json;
using Syncfusion.Linq;
using System.Collections;
using Syncfusion.JavaScript.DataSources;
using Microsoft.AspNetCore.Http;

namespace WebApplication8.Controllers
{
    public class HomeController : Controller
    {


      //  public static List<Orders> order = new List<Orders>();
        public IActionResult Index()
        {

              var data = GetData();        
              ViewBag.data = data;
            //BindDataSource();
            return View();

        }

        public static List<Orders> order = new List<Orders>();

      //  List<Employees> emp = new List<Employees>();
        public void BindDataSource()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin"));
                order.Add(new Orders(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid"));
                order.Add(new Orders(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester"));
                order.Add(new Orders(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                order.Add(new Orders(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                code += 5;
            }
        }
        public ActionResult DataSource([FromBody]DataManager dm)
        {

            IEnumerable data = order;
            DataOperations operation = new DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                data = operation.PerformSorting(data, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                data = operation.PerformWhereFilter(data, dm.Where, dm.Where[0].Operator);
            }
            int count = data.Cast<Orders>().Count();
            if (dm.Skip != 0)  //paging
            {
                data = operation.PerformSkip(data, dm.Skip);
            }
            if (dm.Take != 0)
            {
                data = operation.PerformTake(data, dm.Take);
            }
            return Json(new { result = data, count = count });


        }

        public ActionResult BatchUpdate( [FromBody]CRUDModel<Orders> changed, [FromBody]CRUDModel<Orders> added, [FromBody]CRUDModel<Orders> deleted)
        {
            // do your database code here
            //    return View();
            return Json(new { order });
        }


        public List<Orders> GetData()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin"));
                order.Add(new Orders(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid"));
                order.Add(new Orders(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester"));
                order.Add(new Orders(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                order.Add(new Orders(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                code += 5;
            }
            return order;
        }

       
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
            }

            [Range(0, int.MaxValue, ErrorMessage = "OrderID must be greater than 0.")]
            public long OrderID { get; set; }
            [StringLength(5, ErrorMessage = "CustomerID must be 5 characters.")]
            public string CustomerID { get; set; }
            [Range(1, 9, ErrorMessage = "EmployeeID must be between 0 and 9.")]
            public int EmployeeID { get; set; }
            [Display(Name = "Freight column")]
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
        }

       
       
        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
